#include "ES135xx.h"
uint8_t Precision=0 ,Heater=0;
byte arr[6];
byte T_H[6];
uint8_t serial_flag=0,T_H_flag=0;
float Temperature,Humidity;
int  duration;
bool ES135xx_i2c_write(int8_t address,int8_t registor)
{
bool rett;
Wire.beginTransmission(address);
Wire.write(registor); 
rett = Wire.endTransmission();
//Serial.print(rett);
return rett;
}

void ES135xx_i2c_read(int8_t address,int8_t num_byte)
{
byte return_arr[10];
Wire.requestFrom(address, num_byte);
for(int i = 0;i < num_byte; i++)
  {
   return_arr[i] = Wire.read();
  }
      if(serial_flag==1)
      {
           for(int i = 0;i < num_byte;i++)
          {
           arr[i]=return_arr[i];
          // Serial.println(return_arr[i],HEX);
          }
          serial_flag=0;
      }
            if(T_H_flag==1)
      {
           for(int i = 0;i < num_byte;i++)
          {
           T_H[i]=return_arr[i];
          // Serial.println(return_arr[i],HEX);
          }
          T_H_flag=0;
      }
 }



int16_t ES135xx_probe(void)
{
    Wire.begin();
    uint32_t serial;
    serial_flag=1;
    return ES135xx_read_serial(&serial);
}

int16_t ES135xx_read_serial(uint32_t* serial)
{
  uint32_t serial_no = 0;
  const uint8_t cmd = ES135xx_CMD_READ_SERIAL;
  int16_t ret;

     ret = ES135xx_i2c_write(ES135xx_ADDRESS,ES135xx_SOFTRESET);
    if (ret)
    { 
        Serial.println("Couldn't find ES135xx in write ");
        return ret;
    }
    delay(100);
    ret = ES135xx_i2c_write(ES135xx_ADDRESS, cmd);
    if (ret)
    { 
      return ret;
    }
     delay(200);
    ES135xx_i2c_read(ES135xx_ADDRESS, 6);
    
     Serial.println("===================");
     if ((crc8(arr, 2) != arr[2]) || (crc8(arr + 3, 2) != arr[5])) 
     {
      Serial.println("Couldn't find ES135xx");
      return false;
     }
     else
     {
    serial_no = arr[0];
    serial_no <<= 8;
    serial_no |= arr[1];
    serial_no <<= 8;
    serial_no |= arr[3];
    serial_no <<= 8;
    serial_no |= arr[4];
    Serial.println(serial_no,HEX);
     }
}

int16_t ES135xx_read_T_H(void)
{
  uint32_t serial_no = 0;
  int16_t ret;
  uint8_t cmd ;
  T_H_flag=1;
  
    if (Heater == NO_HEATER) 
  {
     if (Precision == PRECISION_HIGH) {
        cmd = ES135xx_NOHEAT_HIGHPRECISION;
        duration = 10;
      }
      if (Precision == PRECISION_MEDIUM) {
        cmd = ES135xx_NOHEAT_MEDPRECISION;
        duration = 5;
      }
      if (Precision == PRECISION_LOW) {
        cmd = ES135xx_NOHEAT_LOWPRECISION;
        duration = 2;
      }
  }

  if (Heater == HIGH_HEATER_1S) 
  {
    cmd = ES135xx_HIGHHEAT_1S;
    duration = 1100;
  }
  if (Heater == HIGH_HEATER_100MS)
  {
    cmd = ES135xx_HIGHHEAT_100MS;
    duration = 110;
  }

  if (Heater == MED_HEATER_1S) {
    cmd = ES135xx_MEDHEAT_1S;
    duration = 1100;
  }
  if (Heater == MED_HEATER_100MS) {
    cmd = ES135xx_MEDHEAT_100MS;
    duration = 110;
  }

  if (Heater == LOW_HEATER_1S) {
    cmd = ES135xx_LOWHEAT_1S;
    duration = 1100;
  }
  if (Heater == LOW_HEATER_100MS) {
    cmd = ES135xx_LOWHEAT_100MS;
    duration = 110;
  }
    ret = ES135xx_i2c_write(ES135xx_ADDRESS, cmd);
    if (ret)
    { 
        Serial.println("Check wiring");
        return ret;
    }
    delay(duration);
    ES135xx_i2c_read(ES135xx_ADDRESS, 6);
    
     if ((crc8(T_H, 2) != T_H[2]) || (crc8(T_H + 3, 2) != T_H[5])) 
     {
     // for(int i = 0;i < 6;i++)
     // Serial.println(T_H[i],HEX);
      return false;
     }
     else
     {
      float t_ticks = (uint16_t)T_H[0] * 256 + (uint16_t)T_H[1];
      float rh_ticks = (uint16_t)T_H[3] * 256 + (uint16_t)T_H[4];
     Temperature = -45 + 175 * t_ticks / 65535;
     Humidity = -6 + 125 * rh_ticks / 65535;

     Humidity = min(max(Humidity, (float)0.0), (float)100.0);
     Serial.print("Temperature=");
     Serial.println(Temperature);
     Serial.print("Humidity=");
     Serial.println(Humidity);
     }
}

static uint8_t crc8(const uint8_t *data, int len) 
{
  const uint8_t POLYNOMIAL(0x31);
  uint8_t crc(0xFF);

  for (int j = len; j; --j) {
    crc ^= *data++;

    for (int i = 8; i; --i) {
      crc = (crc & 0x80) ? (crc << 1) ^ POLYNOMIAL : (crc << 1);
    }
  }
  return crc;
}
