
#include <Arduino.h>
#include <Wire.h>

#define PRECISION_HIGH       0
#define PRECISION_MEDIUM     1
#define PRECISION_LOW        2

#define  NO_HEATER             0
#define  HIGH_HEATER_1S        1
#define  HIGH_HEATER_100MS     2
#define  MED_HEATER_1S         3
#define  MED_HEATER_100MS      4
#define  LOW_HEATER_1S         5
#define  LOW_HEATER_100MS      6

#define ES135xx_NOHEAT_HIGHPRECISION  0xFD /**< High precision measurement, no heater */
#define ES135xx_NOHEAT_MEDPRECISION   0xF6 /**< Medium precision measurement, no heater */
#define ES135xx_NOHEAT_LOWPRECISION   0xE0 /**< Low precision measurement, no heater */

#define ES135xx_CMD_READ_SERIAL 0x89
#define ES135xx_CMD_DURATION_USEC 1000

#define ES135xx_HIGHHEAT_1S       0x39 /**< High precision measurement, high heat for 1 sec */
#define ES135xx_HIGHHEAT_100MS    0x32 /**< High precision measurement, high heat for 0.1 sec */
#define ES135xx_MEDHEAT_1S        0x2F /**< High precision measurement, med heat for 1 sec */
#define ES135xx_MEDHEAT_100MS     0x24 /**< High precision measurement, med heat for 0.1 sec */
#define ES135xx_LOWHEAT_1S        0x1E /**< High precision measurement, low heat for 1 sec */
#define ES135xx_LOWHEAT_100MS     0x15 /**< High precision measurement, low heat for 0.1 sec */

#define ES135xx_ADDRESS 0x44

#define ES135xx_SOFTRESET 0x94  /**< Soft Reset */

int16_t ES135xx_read_serial(uint32_t* serial);

bool ES135xx_i2c_write(int8_t address,int8_t registor);

void ES135xx_i2c_read(int8_t address,int8_t num_byte);

static uint8_t crc8(const uint8_t *data, int len);

int16_t ES135xx_probe(void);

int16_t ES135xx_read_serial(uint32_t* serial);

int16_t ES135xx_read_T_H(void);
